module CacheUtil where

import qualified Data.Map as M
import Maybe

make_cache_fn :: Ord arg_t =>
                 (arg_t -> result_t) ->
                 [arg_t] ->
                 (arg_t -> result_t)
make_cache_fn fn args =
    let associations = [(arg, fn arg) | arg <- args]
        map = M.fromList associations
    in  \ arg -> fromJust (M.lookup arg map)

make_cache_fn_2 :: (Ord arg1_t, Ord arg2_t) =>
                   (arg1_t -> arg2_t -> result_t) ->
                   [arg1_t] ->
                   [arg2_t] ->
                   (arg1_t -> arg2_t -> result_t)
make_cache_fn_2 fn args1 args2 =
    let args = [(arg1, arg2) | arg1 <- args1, arg2 <- args2]
    in  curry (make_cache_fn (uncurry fn) args)
