module CopPluginCacheImpl where

import State
import CopPluginCache
import CopPlugins
import PlotCourse
import LegalMoves

cpi_cache_init :: CopPlugins -> WorldSkeleton -> CopPluginCache
cpi_cache_init _ ws =
    CopPluginCache {
        cpi_cache_legal_moves =
            make_legal_moves_cache_fn ws (legal_moves ws),
        cpi_cache_legal_moves_same_state =
            make_legal_moves_cache_fn ws (legal_moves_same_state ws),
        cpi_cache_legal_anti_moves =
            make_legal_moves_cache_fn ws (legal_anti_moves ws),

        cpi_cache_plot_course = make_plot_course_cache ws (plot_course ws),

        cpi_cache_states_up_to_distance = states_up_to_distance,
        cpi_cache_states_at_distance = states_at_distance,
        cpi_cache_locs_up_to_distance = locs_up_to_distance,
        cpi_cache_locs_at_distance = locs_at_distance,

        cpi_cache_states_up_to_distance_same_state =
            states_up_to_distance_same_state,
        cpi_cache_states_at_distance_same_state =
            states_at_distance_same_state,
        cpi_cache_locs_up_to_distance_same_state =
            locs_up_to_distance_same_state,
        cpi_cache_locs_at_distance_same_state =
            locs_at_distance_same_state
    }
    where
    ((states_up_to_distance, states_at_distance),
     (locs_up_to_distance, locs_at_distance)) =
        make_by_distance_cache_fns ws (legal_moves ws)
    ((states_up_to_distance_same_state, states_at_distance_same_state),
     (locs_up_to_distance_same_state, locs_at_distance_same_state)) =
        make_by_distance_cache_fns ws (legal_moves_same_state ws)
