module CopPluginLogImpl where

import State
import CopPluginLog
import CopPlugins

cpi_log_init :: CopPlugins -> WorldSkeleton -> CopPluginLog
cpi_log_init _ ws =
    CopPluginLog {
        cpi_log_skeleton = ws,
        cpi_log_update = error "No update",
        cpi_log_sent_informs = error "No sent informs",
        cpi_log_received_informs = error "No received informs",
        cpi_log_sent_plans = error "No sent plans",
        cpi_log_received_plans = error "No received plans",
        cpi_log_vote = error "No vote",
        cpi_log_winner = error "No winner",
        cpi_log_move = error "No move"
    }

cpi_log_pre_inform ::
    CopPlugins -> CopPlugins -> CopPluginLog -> WorldUpdate ->
    CopPluginLog
cpi_log_pre_inform _ _ plugin wu =
    plugin { cpi_log_update = wu }

cpi_log_post_inform ::
    CopPlugins -> CopPlugins -> CopPluginLog -> [Inform] ->
    CopPluginLog
cpi_log_post_inform _ _ plugin informs =
    plugin { cpi_log_sent_informs = informs }

cpi_log_pre_plan ::
    CopPlugins -> CopPlugins -> CopPluginLog ->
    [(PlayerName, [Maybe Inform])] ->
    CopPluginLog
cpi_log_pre_plan _ _ plugin informs =
    plugin { cpi_log_received_informs = informs }

cpi_log_post_plan ::
    CopPlugins -> CopPlugins -> CopPluginLog -> [Plan] ->
    CopPluginLog
cpi_log_post_plan _ _ plugin plans =
    plugin { cpi_log_sent_plans = plans }

cpi_log_pre_vote ::
    CopPlugins -> CopPlugins -> CopPluginLog ->
    [(PlayerName, [Maybe Plan])] ->
    CopPluginLog
cpi_log_pre_vote _ _ plugin plans =
    plugin { cpi_log_received_plans = plans }

cpi_log_post_vote ::
    CopPlugins -> CopPlugins -> CopPluginLog -> [PlayerName] ->
    CopPluginLog
cpi_log_post_vote _ _ plugin vote =
    plugin { cpi_log_vote = vote }

cpi_log_pre_move ::
    CopPlugins -> CopPlugins -> CopPluginLog -> Winner ->
    CopPluginLog
cpi_log_pre_move _ _ plugin winner =
    plugin { cpi_log_winner = winner }

cpi_log_post_move ::
    CopPlugins -> CopPlugins -> CopPluginLog -> CopMove ->
    CopPluginLog
cpi_log_post_move _ _ plugin move =
    plugin { cpi_log_move = move }
