module Dbg where

import Monad
import IO

data Dbg = Dbg {
   dbg_verbose :: Bool,
   dbg_head :: String
}

dbgPutStrLn :: Dbg -> String -> IO ()
dbgPutStrLn dbg str =
    when (dbg_verbose dbg) (hPutStrLn stderr str)

dbgPutStrLnHead :: Dbg -> String -> IO ()
dbgPutStrLnHead dbg str =
    dbgPutStrLn dbg $ dbg_head dbg ++ str

dbgPutStr :: Dbg -> String -> IO ()
dbgPutStr dbg str =
    when (dbg_verbose dbg) (hPutStr stderr str)

dbgPutStrHead :: Dbg -> String -> IO ()
dbgPutStrHead dbg str =
    dbgPutStr dbg $ dbg_head dbg ++ str
