module ForceUtil where

type SeqFn a b = a -> b -> b

no_seq :: SeqFn a b
no_seq x y = y

seq_list :: SeqFn a b -> SeqFn [a] b
seq_list _ [] y = y
seq_list seq_item_fn (x:xs) y = seq_item_fn x (seq_list seq_item_fn xs y)

seq_string :: SeqFn String b
seq_string = seq_list seq

seq_show :: Show a => SeqFn a b
seq_show x y = seq_string (show x) y
