module ListUtil where

-- stolen verbatim from Koen Claessen (on Haskell mailing list 2002-06-10)
-- except for the base case of "permutations"
selections []     = []
selections (x:xs) = (x,xs) : [ (y,x:ys) | (y,ys) <- selections xs ]

permutations :: [a] -> [[a]]
permutations [] = [[]]
permutations xs =
  [ y : zs
  | (y,ys) <- selections xs
  , zs     <- permutations ys
  ]

cartesian_product :: [[a]] -> [[a]]
cartesian_product [] = [[]]
cartesian_product (l:ls) =
    [(x:xs) | x <- l, xs <- cartesian_product ls]

compare_by :: Ord b => (a -> b) -> a -> a -> Ordering
compare_by f x y = compare (f x) (f y)

-- Filters a list, keeping only those items that are strictly greater
-- than the preceding items
ascending_by :: (a -> a -> Ordering) -> [a] -> [a]
ascending_by _ [] = []
ascending_by _ [x] = [x]
ascending_by compare_fn (x:y:xs)
    | compare_fn x y == LT = (x:ascending_by compare_fn (y:xs))
    | otherwise            = ascending_by compare_fn (x:xs)

descending_by :: (a -> a -> Ordering) -> [a] -> [a]
descending_by compare_fn = ascending_by (flip compare_fn)
