module RandomUtil where

import Random
import List

import ListUtil

random_list_elt :: [elt_t] -> IO elt_t
random_list_elt xs =
    do index <- getStdRandom (randomR (0, length xs - 1))
       return (xs !! index)

random_list_perm :: [elt_t] -> IO [elt_t]
random_list_perm [] = return []
random_list_perm xs =
    do index <- getStdRandom (randomR (0, length xs - 1))
       let (xs_left, x : xs_right) = splitAt index xs
       rest <- random_list_perm (xs_left ++ xs_right)
       return (x : rest)

random_list_perm_fn :: RandomGen randomgen_t =>
                       [elt_t] ->
                       randomgen_t ->
                       ([elt_t], randomgen_t)
random_list_perm_fn xs g =
    let (g1, g2) = split g
        ints :: [Int]
        ints = randoms g1
        ys = map snd (sortBy (compare_by fst) (zip ints xs))
    in  (ys, g2)
