module RobberPluginLogImpl where

import State
import RobberPluginLog
import RobberPlugins

rpi_log_init :: RobberPlugins -> WorldSkeleton -> RobberPluginLog
rpi_log_init _ ws =
    RobberPluginLog {
        rpi_log_skeleton = ws,
        rpi_log_update = error "No update",
        rpi_log_received_plans = error "No received plans",
        rpi_log_move = error "No move"
    }

rpi_log_pre_inform ::
    RobberPlugins -> RobberPlugins -> RobberPluginLog -> WorldUpdate ->
    RobberPluginLog
rpi_log_pre_inform _ _ plugin wu =
    plugin { rpi_log_update = wu }

rpi_log_pre_vote ::
    RobberPlugins -> RobberPlugins -> RobberPluginLog -> [[Maybe Plan]] ->
    RobberPluginLog
rpi_log_pre_vote _ _ plugin plans =
    plugin { rpi_log_received_plans = plans }

rpi_log_post_move ::
    RobberPlugins -> RobberPlugins -> RobberPluginLog -> RobberMove ->
    RobberPluginLog
rpi_log_post_move _ _ plugin move =
    plugin { rpi_log_move = move }
