module RobberPluginsImpl where

import State
import RobberPlugins
import RobberPluginLogImpl
import RobberPluginCacheImpl

robber_plugins_init :: WorldSkeleton -> RobberPlugins
robber_plugins_init ws =
    plugins where plugins = RobberPlugins {
        rpi_log = rpi_log_init plugins ws,
        rpi_cache = rpi_cache_init plugins ws,
        rpi_dummy = ()
    }

robber_plugins_pre_inform old wu =
    new where new = old {
        rpi_log = rpi_log_pre_inform old new (rpi_log old) wu,
        rpi_dummy = ()
    }

robber_plugins_post_inform old _ = old
robber_plugins_pre_plan old _ = old
robber_plugins_post_plan old _ = old
robber_plugins_pre_vote old _ = old
robber_plugins_post_vote old _ = old
robber_plugins_pre_bribe old _ = old
robber_plugins_post_bribe old _ = old
robber_plugins_pre_move old _ = old

robber_plugins_post_move :: RobberPlugins -> RobberMove -> RobberPlugins
robber_plugins_post_move old move =
    new where new = old {
        rpi_log = rpi_log_post_move old new (rpi_log old) move,
        rpi_dummy = ()
    }

